<div class="user-container">

  <nz-card style="width:1000px;"
           [nzTitle]="this.loggedUserData?.username +'\'s profile information'"
           [nzExtra]="extraTemplate"
           [nzHoverable]="true"
           class="nz-card">
    <div nz-row>
      <div class="user-information"
           nz-col
           nzSpan="10">
        <div class="user-avatar">
          <nz-avatar nzIcon="user"
                     nzShape="square"
                     [nzSize]="128"
                     [nzSrc]="this.userAvatar"></nz-avatar>
          <nz-upload [nzAction]="this.uploadUrl"
                     (nzChange)="uploadAvatar($event)">
            <button nz-button
                    class="upload-button"><i nz-icon
                 nzType="upload"></i>Click to Upload</button>
          </nz-upload>
        </div>

        <div class="user-details">
          <p class="detail-labels">Username: <span class="user-details"> {{this.loggedUserData?.username}} </span> </p>
          <p class="detail-labels">Name: <span class="user-details"> {{this.loggedUserData?.name}} </span> </p>
          <p class="detail-labels">Email: <span class="user-details"> {{this.loggedUserData?.email}} </span> </p>
          <p class="detail-labels">Role: <span class="user-details"> {{this.loggedUserData?.role}} </span> </p>
        </div>
      </div>

      <div class="user-update-information"
           nz-col
           nzSpan="14">
        <div class="user-edit-container">
          <form nz-form
                nz-row
                [formGroup]="this.validateNameForm"
                #formName="ngForm"
                class="user-name-form"
                (ngSubmit)="submitNameForm(formName)">
            <div class="form-item"
                 nz-col
                 nzSpan="20">
              <nz-form-item nz-row>
                <nz-form-label nz-col
                               [nzSpan]="8"
                               class="edit-details-labels">Name</nz-form-label>
                <nz-form-control class="input-group"
                                 nzHasFeedback
                                 nz-col
                                 [nzSpan]="14"
                                 [nzErrorTip]="userErrorTpl">
                  <nz-input-group>
                    <input type="text"
                           nz-input
                           formControlName="name"
                           placeholder="change your name..." />
                  </nz-input-group>
                  <ng-template #userErrorTpl
                               let-control>
                    <ng-container *ngIf="control.hasError('minlength') || control.hasError('maxlength')">
                      Name should be between 3 and 35 characters!
                    </ng-container>
                  </ng-template>
                </nz-form-control>
              </nz-form-item>
            </div>
            <div class="form-save-button"
                 nz-col
                 nzSpan="4">
              <button nz-button
                      class="user-name-button"
                      [nzType]="'primary'"
                      type="submit"
                      [disabled]="!this.validateNameForm.valid">Save</button>
            </div>
          </form>
        </div>

        <div class="password-edit-container">

          <form nz-form
                [formGroup]="this.validatePasswordForm"
                #formPassword="ngForm"
                nz-row
                (ngSubmit)="submitPasswordForm(formPassword)"
                class="user-password-form">
            <div class="password-form-item"
                 nz-col
                 nzSpan="20">

              <nz-form-item nz-row>
                <nz-form-label nz-col
                               nzSpan="8"
                               nzRequired
                               class="edit-details-labels">Password</nz-form-label>
                <nz-form-control class="input-group"
                                 nzHasFeedback
                                 nz-col
                                 nzSpan="14"
                                 [nzErrorTip]="passwordError">
                  <input type="password"
                         nz-input
                         formControlName="password"
                         (ngModelChange)="this.validatePasswordForm.controls['confirmPassword'].updateValueAndValidity()"
                         placeholder="change your password..." />
                  <ng-template #passwordError
                               let-control>
                    <ng-container
                                  *ngIf="control.hasError('minlength') || control.hasError('maxlength') ||control.hasError('pattern') ">
                      Password must be more than 5 characters containt
                      at least one letter, one number and one special character!
                    </ng-container>
                  </ng-template>
                </nz-form-control>
              </nz-form-item>

              <nz-form-item nz-row>
                <nz-form-label nz-col
                               nzSpan="8"
                               nzRequired
                               class="edit-details-labels">Confirm Password</nz-form-label>
                <nz-form-control nz-col
                                 class="input-group"
                                 nzSpan="14"
                                 nzHasFeedback
                                 [nzErrorTip]="confirmPasswordError">
                  <input nz-input
                         type="password"
                         formControlName="confirmPassword"
                         placeholder="confirm your password..." />
                  <ng-template #confirmPasswordError
                               let-control>
                    <ng-container *ngIf="control.hasError('required')">
                      Please confirm your password!
                    </ng-container>
                    <ng-container *ngIf="control.hasError('passwordsNotTheSame') && !control.hasError('required')">
                      Password is inconsistent!
                    </ng-container>
                  </ng-template>
                </nz-form-control>
              </nz-form-item>
            </div>

            <div class="password-save-button"
                 nz-col
                 nzSpan="4">
              <button nz-button
                      class="user-pass-button"
                      [nzType]="'primary'"
                      type="submit"
                      [disabled]="!this.validatePasswordForm.valid">Save</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </nz-card>
</div>
<ng-template #extraTemplate>
</ng-template>
